    !  HEBE.f90
    !
    !  FUNCTIONS:
    !  HEBE - Entry point of console application.
    !

    !****************************************************************************
    !
    !  PROGRAM: HEBE
    !
    !  PURPOSE:  Entry point for the console application.
    !
    !****************************************************************************

    program HEBE

    implicit none
    !       MATRIX STIFFNESS METHOD OF INESLASTIC FRAME ANALYSIS
    !       THESIS PROJECT , BY S+SALLAM . GRADUATE STUDENT ,
    !       DEPARTMENT OF CIVIL ENGINEERING , MCMASTER UNIVERSITY, HAMILTON, ONTARIO, CANADA
    !       A JOINT IS CONSIDERED TO EXIST AT EACH POINT OF LOAD APPLICATION
    !       AND AT POINTS OF GEOMETRIC DISCONTINUITY. LOADS ARE PERMITTED
    !       ONLY AT JOINTS AND MUST BE DISCRETE VALUES (DISTRIBUTED LOADS ARE
    !       THUS REPLACED BY EQUIVALENT SYSTEMS OF DISCRETE FORCES).
    !       ASSIGN JOINT NUMBERS TO ALL 'JOINTS' IN STRUCTURE, INCLUDING BOTH
    !       ACTUAL JOINTS (GEOMETRIC DISCONTINUITIES) AND POINTS OF
    !       APPLICATION OF CONCENTRATED LOADS.
    !       ALL LOADINGS IN THE PLANE OF THE FRAME (X,Y) ARE PERMITTED,
    !       EXCEPT TORSIONAL MOMENTS.
    !       ASSIGN MEMBER NUMBERS TO ALL MEMBERS. MEMBER END i is DEFINED TO
    !       BE THE END AT THE LOWER OF THE TWO JOINT NUMBERS WHICH
    !       CORRESPOND TO THE JOINTS CONNECTED BY THE MEMBER.
    !       WLIVE = SUPERIMPOSED. LOAD IN KIP PER LINEAR FOOT
    !       CF=SCALE FACTOR OF LENGTH, IF IN., CF=1.0, IF FT.,CF=12.0
    !       MEMTYP = 1     FOR PIN-PIN
    !       MEMTYP = 2     FOR  FIX-FIX
    !       MEMTYP = 3     FOR  PIN-FIX
    !       MEMTYP = 4     FOR  FIX-PIN
    !       SIGN CONVENTION FOR FORCE VECTOR TENSION POSITIVE
    !       SHEAR POSITIVE CLOCKWISE
    !       BENDING MOMENT POSITIVE IF TOP FIBRE IN COMPRESSION .
    !       DISPLACEMENT VECTOR IN GLOBAL COORDINATE
    !       FORCE VECTOR IN MEMBER COORDINATE

    !-----------------------------------------------------------------------------------------------------------
    INTEGER I, JN, MN, M0, N1, N2, JLS, NM1, NM2, NSTRIP, J, MCYCL, NSE, INDEXX, KADD, NCYCL,KCYCL, KONT
    Integer KADD2, KONT1
    REAL WCONC, WCON, ECON, ECS, DTH1,DB1,AST1,ASC1,DST1,DSC1, RPT,RPC,DPD,ZETA, T1, T2, ERROR, ERR1, ERR2
    REAL STRAIN, W, BM, BMCAL1, P, TL, NEB, PAX1,RMCL,DCGC,TI, BMCL, WBOT, WP1, DNAX3, PHIP1,PHI1,WW1,DNAX1
    REAL WCGC1,WCGCP1,WAXIAL1, WWL,PHID, WUW,WTN, RATIO, RATIO1,RATIO2,RATIOI,RATIOA, TDEL
    !-----------------------------------------------------------------------------------------------------------

    REAL DDTH(150), DDB(150),AAST(150),AASC(150),DDST(150),DDSC(150)
    REAL EI(150), EA(150), FA(150), FV(150),BMC(150)
    REAL EIII(20,30),EAAA(20,30)
    CHARACTER*8 TITLE(10)
    REAL GI(150)
    REAL FXX1(150), FYY1(150), FMM1(150)
    REAL WU2(20,20), UUF1(20,20), UUF2(20,20), EEI(30)
    REAL WEEP(20,20), WU1(20,20), CEEP(20,20), EEA(30)
    REAL WWW2(30), PPH2(30), WWP2(30), PPHI2(30)
    REAL FYA(100), FMA(100) ,WWW1(30), PPHI(30), WWP1(30), PPHIP(30),FXA(100)
    Integer NEE(50)
    REAL EEAA(30)
    INTEGER ND(100,3)
    REAL X(100),Y(100)
    INTEGER JNL(150), JNG(150),MEMTYP(150),NJOIN, NELEM
    REAL CF
    INTEGER NJL , JNN(100)
    REAL FXX(100), FYY(100),FMM(100), AL(150),XM(150) ,YM(150)
    REAL DTH,DB,AST,ASC,DST,DSC
    REAL WSHRINS, WSHRINC, WTENSIL, WY, FSY, CYL, TCF
    INTEGER NALLOW
    REAL ES
    REAL PHITRI, WTRIAL
    INTEGER NPLAST, NSEX, NWIND
    REAL WLIVE,WIND, WIN, WLIV
    Integer FLAG, LIST(100)

    COMMON /BLCK1/ ND, X, Y, JNL, JNG, MEMTYP
    COMMON /BLCK2/ NJOIN, NELEM, CF, NJL
    COMMON /BLCK3/ JNN, FXX, FYY,FMM
    COMMON /BLCK5/ AL,XM ,YM
    COMMON /BLOCK1/ DTH,DB,AST,ASC,DST,DSC
    COMMON /BLOCK3/ WSHRINS, WSHRINC
    COMMON /BLOCK4/ WTENSIL, WY, FSY, CYL, TCF, NALLOW, ES
    COMMON /BLOCK5/ PHITRI, WTRIAL



    !   These are assumed as not set in original

    T1 = 0.0
    ERROR = 0.0
    ERR1 = 0.0
    ERR2 = 0.0
    BM = 0.0
    KADD = 0
    BMCAL1 = 0.0
    P = 0.0
    WP1 = 0.0
    WCGC1 = 0.0
    WCGCP1 = 0.0
    WAXIAL1 = 0.0
    WWL = 0.0
    PHID = 0.0
    WUW = 0.0
    WTN = 0.0
    KADD2 = 0
    RATIO = 0.0
    RATIO1 = 0.0
    RATIO2 = 0.0
    RATIOI = 0.0
    RATIOA = 0.0
    KONT1 = 0
    TDEL = 0.0
    WIN = 0.0
    WLIV = 0.0
    JLS = 0
    M0 = 0
    FLAG = 0
    LIST = -1

    OPEN(10,FILE="A.in", STATUS = "OLD")
    OPEN(11,FILE="A.out", STATUS = "UNKNOWN")
    OPEN(12,FILE="A.txt", STATUS = "UNKNOWN")

    READ(10,1101)TITLE
1101 FORMAT(10A8)
1102 FORMAT(//,20X,"    MCMASTER UNIVERSITY PROGRAM FOR ANALYSIS OF COLUMNS - 1967 ",/&
        20X "    Job Title :: ",10A8,//&
        20X,"    Material Properties ----------- English Units ")
    WRITE(*,1101)TITLE
    WRITE(12,1102)TITLE


    !   READ CYLINDER STRENGTH, STEEL YIELD STRESS, MODULUS OF
    !   ELASTICITY OF STEEL, TENSILE STRENGTH OF CONCRETE, INITIAL
    !   SHRINKAGE.    ==============  ADDED E for Concrete

    READ(10,*)CYL,FSY,ES, WTENSIL, WSHRINC, ECON
2   FORMAT( /,20X,"    Cylinder Strength              :: ",F10.3,&
        /,20X,"    Steel Yield Stress             :: ",F10.3,&
        /,20X,"    Modulus of Elasticity of Steel :: ",F10.3,&
        /,20X,"    Tensile Strength of Concrete   :: ",F10.3,&
        /,20X,"    Initial Shrinkage              :: ",F10.3,&
        /,20X,"    Concrete Elastic Modulus       :: ",F10.3)

    Write(*,2)CYL,FSY,ES, WTENSIL, WSHRINC, ECON
    Write(12,2)CYL,FSY,ES, WTENSIL, WSHRINC, ECON

    !   READ  NUMBER  OF   JOINTS, NUMBER  OF  ELEMENTS, NUMBER  OF  ELEMENTS
    !   THAT   NEEDS  MODIFICATION FOR THEIR STIFFNESSES, SCALE FOR
    !   CONVERTING ALL DIMENSIONS.  TO INCHES=12.0 IF THE FRAME'S
    !   ORDINATES ARE GIVEN IN FT.

    READ(10,*)NJOIN,NELEM,NPLAST,CF
15  FORMAT(3I10,F10.2)
17  FORMAT( /,20X,"    Frame Properties and Data",&
        //,20X,"    Number of Joints           :: ",I10,&
        /,20X,"    Number of Elements         :: ",I10,&
        /,20X,"    Number of Plastic Elements :: ",I10,&
        /,20X,"    English Unit Factor        :: ",F10.2,//)
    Write(*,15) NJOIN,NELEM,NPLAST,CF
    Write(12,17) NJOIN,NELEM,NPLAST,CF

    !   READ INITIAL LIVE LOAD, INITIAL WIND LOADS.

    READ(10,*)WLIVE,WIND
7868 FORMAT(2F10.3)
7867 FORMAT( /,20X,"    Live Load and Wind Load Data",&
        //,20X,"    Live Load                  :: ",F10.3,&
        /,20X, "    Wind Load                  :: ",F10.3)
    write(*,7868)WLIVE,WIND
    write(12,7867)WLIVE,WIND

    !   READ THE NUMBER OF THE MOST CRITICAL ELEMENT IN THE COLUMN.

    READ(10,*)NSEX
1988 Format(I5)
1986 Format( /,20X,"    Critical Column Element Data",&
        //,20X,"    Critical Element Number    :: ",I10)
    WRITE(*,1988)NSEX
    WRITE(12,1986)NSEX

    !   READ   THE   NUMBER OF WIND INCREMENTS TO BE ADDED

    READ(10,*)NWIND

    WRITE(*,1988)NWIND

    WRITE(12,1985)NWIND
1985 Format( /,20X,"    Number of Wind Elements",&
        //,20X,"    Number                     :: ",I10)

    DO 1989   I=1,NWIND
        READ(10,*)NEE(I)
        Write(*,1988)NEE(I)
        Write(12,1988)NEE(I)
1989 END DO

    WIN=WIND
    WLIV = WLIVE

    Do 1060 I = 1,NJOIN
      LIST(I) = 0
1060 End do      
    DO 1004 I=1, NJOIN

        !   READ THE JOINT NUMBER, THE NUMBERS  OF  THE   THREE  POSSIBLE
        !   DISPLACEMENTS AT THAT JOINT, X-COORDINATE, Y-COORDINATE.

        READ(10,*)JN,ND(I,1), ND(I,2), ND(I,3),X(I), Y(I)
        Write(*,1438)JN,ND(I,1), ND(I,2), ND(I,3),X(I), Y(I)
        LIST(ND(I,1)) = 1
        LIST(ND(I,2)) = 1
        LIST(ND(I,3)) = 1
        Write(12,1436)JN,ND(I,1), ND(I,2), ND(I,3),X(I), Y(I)
1438    FORMAT(4I5,2F10.3)
1436    FORMAT(/,20X,"    Element Data",&
            /,20X,"    Element Number             :: ",I10,&
            /,20X,"    Displacement 1             :: ",I10,&
            /,20X,"    Displacement 2             :: ",I10,&
            /,20X,"    Rotation                   :: ",I10,&
            /,20X,"    X Position                 :: ",F10.3,&
            /,20X,"    Y Position                 :: ",F10.3)
1004 CONTINUE

    Write(12,1434)
1434 Format(/,20X,"    Element Number and Joint Data",&
        /,20X,"    Number     Joint A   Joint B    Member Type ")
    Do 1007 I = 1, NELEM
        !   READ THE ELEMENT NUMBER, THE NUMBERS OF THE TWO JOINTS AT THE
        !   ENDS  OF   THIS   ELEMENT   ,   AND   THE   MEMBER   TYPE   (TO   DETERMINE  THE
        !   MEMBER   TYPE   SEE   NOTES   IN   THE   BEGINNING  OF   THE^PROGRAM)

        READ(10,*)MN,JNL(I),JNG(I),MEMTYP(I)
1437    FORMAT(4I5)
1432    FORMAT(20X,4I10)
        WRITE(*,1437)MN,JNL(I),JNG(I),MEMTYP(I)
        WRITE(12,1432)MN,JNL(I),JNG(I),MEMTYP(I)
1007 END DO


    Write(12,1433)
1433 Format(/,20X,"    Section Property Data",&
        /,20X,"    Number  Depth        Breadth      Area Steel     Area Steel   Effective        Cover",&
        /,20X,"    Element  in            in        Compression      Tension    Concrete Depth      in",&
        /,20X,"                                       squ. in.       squ. in.      in.")

    DO 1376 I = 1,NELEM

        !   READ THE PROPERTIES OF EACH ELEMENT-(THE DEPTH, BREADTH, AREA OF
        !   STEEL IN TENSION, AREA QF STEEL IN COMPRESSION, EFFECTIVE CONCRETE
        !   DEPTH, COVER OF THE TENSION STEEL)

        READ(10,*)DDTH(I),DDB(I),AAST(I),AASC(I),DDST(I), DDSC(I)
        Write(*,1447)I,DDTH(I),DDB(I),AAST(I),AASC(I),DDST(I), DDSC(I)
        Write(12,1446)I,DDTH(I),DDB(I),AAST(I),AASC(I),DDST(I), DDSC(I)
1447    FORMAT(I5, 6F10.3)
1446    FORMAT(20X,I7, (1x,F10.3),5(4x,F10.3))
1376 END DO


    M0= 0
    TCF = 0.0

    !   READ THE NUMBER OF JOINTS LOADED IN THE STRUCTURE.

8147 READ(10,*)NJL
    Write(*,8148)NJL
    Write(12,8146)NJL
8148 FORMAT(I5)
8146 FORMAT(/,20X,"    Number of Loaded Joints",&
        /,20X,"    Number                     :: ",I10,&
        //,20X,"    Element Joint 1  Joint 2   X Distance  Y Distance     Length ",&
        /,20X,"                                    in          in          in")

    IF(NJL .GE. 1000)   GOTO   4373               !    Error Check, but this does not actually work.

    DO 7310 I  = 1, NELEM
        N1=JNL(I)
        N2 = JNG(I)
        XM(I) = CF*(X(N2) - X(N1))
        YM(I) = CF*(Y(N2) - Y(N1))
        AL(I)= sqrt(XM(I)*XM(I) + YM(I)*YM(I))
        write(*,7311)I,N1, N2,XM(I),YM(I),AL(I)
        write(12,7309)I,N1, N2,XM(I),YM(I),AL(I)
7311    Format(3I5,3F10.3)
7309    Format(20X,3I8,5X,F10.3,2(3X,F10.3))
7310 END DO

1974 CONTINUE

    DO 1332 I=1,NJOIN
        FXX(I) =   0.0
        FYY(I) =   0.0
        FMM(I) = 0.0
1332 END DO


    WCONC = 150.0
    Write(*,1333)WCONC
    Write(12,1333)WCONC
1333 Format(/,20X,"    Unit mass of concrete      :: ",F10.3)

    IF(WIND .GT. WIN) THEN
        Write(12,2000)WIND, WIN
2000    Format(/,20X,"    Some form of Wind Error",&
            /,20X,"    Wind Value                 :: ",F10.3,&
            /,20X,"    Win  Value                 :: ",F10.3,&
            /,20X,"    They should be the same - no idea how they are not!")
        GOTO 1975
    ENDIF

    IF(WLIVE .GT. WLIV)THEN
        Write(12,2012)WIND, WIN
2012    Format(/,20X,"    Some form of Live Load Error",&
            /,20X,"    WLIVE Value                :: ",F10.3,&
            /,20X,"    WLIV  Value                :: ",F10.3,&
            /,20X,"    They should be the same - no idea how they are not!")

        GO TO 1975
    ENDIF
    IF(NJL .EQ. 0)  THEN
        Write(12,2014)NJL
2014    Format(/,20X,"    Some form of Loaded Joint Number Error",&
            /,20X,   "    Cannot be zero adjust      :: ",I10)
        GOTO 1336
    ENDIF

    write(12,2015)
2015 Format(/,20X,"    Loaded Joint Data",&
        /,20X,"    Joint      FX            FY         MX",&
        /,20X,"              kips          kips      in-kips")
    DO  904 I=1, NJL

        !   READ THE NUMBER OF THE JOINT LOADED, THE LOAD IN THE X-DIRECTION
        !   THE LOAD IN THE Y-DIRECTION, AND THE CONCENTRATED COUPLE AT THAT JOINT IF ANY.

        READ(10,*)JNN(I),FXA(I),FYA(I),FMA(I)
        Write(*,55)JNN(I),FXA(I),FYA(I),FMA(I)
        Write(12,155)JNN(I),FXA(I),FYA(I),FMA(I)
55      Format(I10,3F10.3)
155     Format(20X,I7,3(3X,F10.3))
904 CONTINUE


    DO   1371 I = 1,NJL
        JLS=   JNN(I)
        FXX(JLS) = FXX(JLS) + FXA(I)
        FYY(JLS) = FYY(JLS) + FYA(I)
        FMM(JLS) = FMM(JLS) + FMA(I)
1371 END DO
1336 CONTINUE

    NJL=NJOIN

    write(12,1338)
1338 Format(/,20X,"    All Joint Load Data",&
        /,20X,"    Joint      FX            FY         MX",&
        /,20X,"              kips          kips      in-kips")

    DO 1331 I= 1,NJOIN
        JNN(I) = I
        Write(12,155)JNN(I),FXX(I),FYY(I),FMM(I)
1331 END DO

    NM1 = 0
    NM2 = 0
    NSTRIP=20
    NALLOW= 100

    write(12,1339)NSTRIP,NALLOW,WTENSIL
1339 Format(/,20X,"    Iteration Limit Data",&
        /,20X,"    Number of Strips           :: ",I10,&
        /,20X,"    Number of Iterations       :: ",I10,&
        /,20X,"    Max. Conc. Tensile Strain  :: ",F10.4)

    DO 1977 J =  1,NPLAST
        DO 1971  I = 1,NSTRIP
            CEEP(J,I) = 0.0
            WEEP(J,I) = 0.0
1971    END DO
1977 END DO

    IF(M0 .GT. 0) THEN
        Write(12,1807)M0
1807    Format(/,20X,"    Some form of M0 Number Error",&
            /,20X,   "    Cannot be anything but zero at this stage, no idea what the original programmer did!      :: ",F10.3)
        GO TO 117
    ENDIF

    M0 = 1

    WRiTE(11,1103)TITLE
1103 FORMAT(1H1,30X,10A8)

    MCYCL = 20
    WCON= 145.00
    WTRIAL = 1.00E-04
    PHITRI = WTRIAL/3.0
    ECS =   ES/ECON                            !  Fixed as this integer NEC
    WY  =   FSY/ES

    write(*,1001)
    write(11,1001)
1001 FORMAT(//,30X,"COMPUTER ANALYSIS OF INELASTIC REINFORCED CONCRETE FRAME", &
        /,30X,"MATRIX METHOD OF STRUCTURAL ANALYSIS",  &
        //, 45X, "THESIS PROJECT. BY S. SALLAM",   &
        /,45X,"DEPARTMENT OF CIVIL ENGINEERING",  &
        /,45X,"MCMASTER   UNIVERSITY"/// )

    WRITE(*,1002)MCYCL
    WRITE(11,1002)MCYCL
    WRITE(12,1802)MCYCL,WTRIAL,PHITRI,ECS,WY
1002 Format(//40X,"ALLOWABLE   MAXIMUM   NO.   OF   ITERATION   :: ",i5)

1802 Format(//,20X,"    Initialize basic data",/&
        /,20X,"    Allowable iterations       :: ",i10,&
        /,20X,"    Strain Trial Estimate      :: ",F10.6,&
        /,20X,"    PHI Trial Estimate         :: ",F10.6,&
        /,20X,"    Ratio of Young's Modulus   :: ",F10.6,&
        /,20X,"    WY                         :: ",F10.6)

    WRITE(*,1003)NJOIN, NELEM, NPLAST
    WRITE(11,1003)NJOIN, NELEM, NPLAST
1003 Format(40X,"NUMBER OF DISCRETE JOINTS        ::   ",I5,/,&
        40X,"NUMBER OF FINITE ELEMENTS        ::   ",I5/,&
        40X,"NUMBER  OF   INELASTIC  ELEMENTS ::   ",i5)

    WRITE(*,8230)NSTRIP, NALLOW,WTENSIL
    WRITE(11,8230)NSTRIP, NALLOW,WTENSIL
8230 FORMAT ( //,40X,"NO. OF ELEMENT STRIP IN EACH CROSS-SECTION               :: ",I5,&
        /,40X,  "PERMISSIBLE NO. OF CYCLE FOR MOMENT-CURVATURE ITERATION  :: ",I5,&
        /,40X,  "MAXIMUM CONCRETE TENSILE STRAIN                          :: ",F5.3)

    WRITE(*,2459)CYL,FSY,ES,WY,ECON
    WRITE(11,2459)CYL,FSY,ES,WY,ECON
2459 Format(//,40X, "CONCRETE CYLINDER STRENGTH AT AGE 21   DAYS :: ",F15.5,&
        /,40X, "YIELD STRENGTH OF STEEL REINFORCEMENT       :: " E15.5,&
        /,40X, "MODULUS  OF  ELASTICITY   OF   STEEL        :: ",E15.5,&
        /,40X, "ULTIMATE STRAIN OF STEEL                    :: ",E15.5,&
        /,40X, "MODULUS OF ELASTICITY OF CONCRETE           :: ",E15.5)


    IF(CF.EQ. 1.0)   THEN
        WRITE(*,8)
        WRITE(11,8)
        WRITE(12,8000)
    ELSE IF(CF.GT.1.0) THEN
        WRITE(*,1728)
        WRITE(11,1728)
        WRITE(12,8000)
    ENDIF

8   FORMAT(//,20X,"JOINT NO.    X DISP NO.      Y  DISP NO.     ROT DISP  NO.         XCORD(IN)      YCOORD(IN)            ",/)
1728 FORMAT(//,20X,"JOINT NO.    X DISP NO.     Y  DISP NO.     ROT DISP  NO.         XCORD(IN)      YCOORD(IN)            ",/)
8000 FORMAT(//,20X,"    Joint Control Data",/&
        /,20X,"    Joint No.    X Disp No.   Y Disp No.     Rot Disp  No.         XCoord          YCoord ",&
        /,20X,"                                                                    (in)            (in)",/)

    Do 1444 I = 1, NJOIN
        Write(*,7)I,ND(I,1),ND(I,2),ND(I,3),X(I),Y(I)
        Write(11,7)I,ND(I,1),ND(I,2),ND(I,3),X(I),Y(I)
        Write(12,7)I,ND(I,1),ND(I,2),ND(I,3),X(I),Y(I)
7       FORMAT(20X,2X,4(I6,8X),8X,2(F8.2,6X))

1444 END DO
    WRITE(*,1453)
    WRITE(11,1453)
1453 FORMAT(//,20X,"GEOMETRIC PROPERTIES OF CONCRETE ELEMENT CROSS-SEC",/,&
        20X,"ELEMENT NO.      THICK        WIDTH          COMP. ASC   TENSION AST   DIST. AST    DIST. ASC         "/)
    DO  1454   I = 1,NELEM
        WRITE(*,1457)I,DDTH(I),DDB(I),AAST(I),AASC(I),DDST(I),DDSC(I)
        WRITE(11,1457)I,DDTH(I),DDB(I),AAST(I),AASC(I),DDST(I),DDSC(I)
1457    FORMAT(20X,I3,5X,6(5X,F10.3))
1454 END DO


    WRITE(12,2454)
2454 Format(/,20X,"    Column Data Calculations ",&
        /,20X,"      I Len   B    D   AST   ASC  DS   DC  Steel Ratios   Ratio  ZETA   GI            EA ",/&
        /,20X,"                                  in   in     %     %     DC/DS")

    DO 1777 I =    1, NELEM
        DTH1 = DDTH(I)
        DB1 = DDB(I)
        AST1 = AAST(I)
        ASC1 = AASC(I)
        DST1 = DDST(I)
        DSC1 = DDSC(I)
        IF(XM(I) .EQ. 0.) THEN
            GOTO 1717
        ENDIF
        RPT = AST1/(DB1*DTH1)
        RPC = ASC1/(DB1*DTH1)
        DPD=DSC1/DST1
        ZETA = ((ECS**2)*((2.0*RPC+RPT)**2)+2.0*ECS*(RPT+ 2.0*RPC+DPD))**0.5-ECS*(2.0*RPC+RPT)            !    Check equation I did and fixed FCS to ECS
        GI(I)= ECON*(DB1*((ZETA*DST1)**3)/3.0+ECS*DB1*DST1*(RPT*(DST1-ZETA*DST1)**2+2.0*RPC*(ZETA*DST1-DSC1)**2))
        EA(I)=ECON*DB1*DTH1
        GOTO   1927
1717    GI(I) = ECON*DB1*DTH1**3/12.0
        EA(I) = ECON*DB1*DTH1
1927    Write(12,1928)I,XM(I),DTH1,DB1,AST1,ASC1,DST1,DSC1,RPT,RPC,DPD,ZETA,GI(I),EA(I)
1928    Format(20X,I7,7(1X,F4.1),4(1X,F6.3),E10.3,2X,F10.3)
1777 End do
117 CONTINUE
    DO   1772 I =   1,NELEM
        EI(I)=  GI(I)
1772 END DO
    WRITE(*,1779)
    WRITE(11,1779)
    WRITE(12,1779)


1779 FORMAT(  /,20X,"    Data for Stiffness Matrix Calculation",&
        //,20X,"    Member No.      Joint No.      Joint No.     Member Type        EI                 EA")

    DO   1771     I= 1,NELEM
        WRITE(*,1778)I,JNL(I),JNG(I),MEMTYP(I),EI(I),EA(I)
        WRITE(11,1778)I,JNL(I),JNG(I),MEMTYP(I),EI(I),EA(I)
        WRITE(12,1778)I,JNL(I),JNG(I),MEMTYP(I),EI(I),EA(I)
1778    Format(13X,4I15,2E20.3)
1771 END DO

    NSE=0
    DO  2123   I=1, NJOIN
        FXX1(I) = FXX(I)
        FYY1(I) = FYY(I)
        FMM1(I) = FMM(I)
2123 END DO
9111 Continue       !This is the loop control for the time period returns from 1111.

    IF(NSE .eq. 0.0) THEN
        Write(12,8007)NSE
8007    Format(/,20X,"     Current Step Number",&
            /,20X,"     NSE                         :: ",I10)
        GOTO 1111
    else
        Write(12,8007)NSE
        !GOTO 1111
    ENDIF

    IF(T1 .GE. 730.0) GOTO 6012                                     !  WHY
    IF(WLIVE .GT. WLIV)GOTO 9373
    IF(WIND .GT. WIN) GOTO 9373

    GOTO 6013

6012 INDEXX=0

    T2 = 730.0
    T1 = T2
    Do 2133 I = 1,NJOIN
        FXX(I)=FXX(I) + 0.1*FXX1(I)
        FYY(I)=FYY(I) + 0.1*FYY1(I)
        FMM(I)=FMM(I) + 0.1*FMM1(I)
2133 CONTINUE
6013 IF(INDEXX .GT. 0) GO TO 8147
    IF(NM1 .GT. 0) GO TO 4373

1975 CONTINUE
    WRITE(*,1976)WLIVE,WIND
1976 FORMAT(40X,"SUPERIMPOSED LOAD :: ",F10.3,10X," WIND LOAD :: ",F10.3)
    WRITE(6,1987)
1987 FORMAT(///   ,50X,"APPLIED  LOAD  VECTOR",/,40X,10HJOINT   NO,3X,&
        5HFX       ,5X,5HFY         ,9X,5HMZ        /)

    DO   1589   I=1,NJOIN
        WRITE(*,56)JNN(I),FXX(I),FYY(I),FMM(I)
56      FORMAT(35X,I10,3F10.3)
1589 CONTINUE
    NCYCL=0
16  NCYCL   =   NCYCL + 1
    KCYCL=NCYCL-1
    WRITE(*,1010)NCYCL,T1,T2
1010 FORMAT(/,20X,"ITERATION   NO. ", 2X, I5,10X,"TIME 1 :: ",F10.3,5X,"TIME   2   :: "   ,F10.3)

    IF(NCYCL.LE.2) GOTO 2001

    DO  2002 I =  1,NPLAST
        EI(I) = (EIII(KCYCL,I)+EIII(KCYCL-1, I))*0.50
        EA(I) = (EAAA(KCYCL,I)+EAAA(KCYCL-1,I))*0.50
2002 END DO

    IF(NCYCL-5)2001,2003,2003
2003 DO  2005 I= 1, NPLAST
        EI(I) = (EIII(KCYCL,I)+ EIII(KCYCL-1,I)+EIII(KCYCL-2 , I)) /3.0
2005 EA(I) = (EAAA(KCYCL,I) +EAAA(KCYCL-1,I) + EAAA (KCYCL-2 , I ) )/3.0

    IF(NCYCL-8) 2001,2006, 2006
2006 DO  2007   I=   1,   NPLAST
        EI(I) = (EIII(KCYCL,I)+EIII(KCYCL-1,I)+EIII(KCYCL-2,I)+EIII(KCYCL-3,I))/4.0
        EA(I) = (EAAA(KCYCL,I)+EAAA(KCYCL-1,I)+EAAA(KCYCL-2,I)+EAAA(KCYCL-3,I))/4.0
        NEB = 0
2007 CONTINUE
2001 Continue
    DO  2009   I=1,NPLAST
        EEI(I)=EI(I)
        EEA(I)=EA(I)
2009 CONTINUE
666 CALL ELASTO(EI,EA, FA,FV,BMC,LIST)
217 WRITE(*,610)
610 FORMAT(/,10X,"WCONC   ",8X, "WTENS  ",6X," Curvature ","     AXIAL P",5X," APPLIED M.       EI            EA         Member No.")
    DO   9991 I = 1,NPLAST
        KONT   =    I
        ASC   =   AASC(I)
        AST   =   AAST(I)
        DB   =   DDB(I)
        DTH   =   DDTH(I)
        DST = DDST(I)
        DSC = DDSC(I)
        PAX1 = EA(I)
        RMCL = ABS(BMC(I))
        DCGC = (DB*DTH**2*0.5+AST*DST+ASC*DSC)/(DB*DTH + ASC + AST)
        IF(TI.GT. 0.0) GO TO 7077
        IF(EA(I) .eq. 0.0) GO TO 7124
        EI(I) = ECON*(DB*DTH**3)/12.0
        EA(I) = DB*DTH*ECON
        DCGC = DTH/2.0
        WTRIAL = (BMCL*DCGC)/EI(I) + PAX1/EA(I)
        WBOT = (BMCL*DCGC)/EI(I) - PAX1/EA(I)
        PHITRI =(WTRIAL + WBOT)/ DTH
        GO TO 7125
7124    WTRIAL = (BMCL*DCGC)/EI(I)
        PHITRI= WTRIAL/DTH
        GOTO 7125
7077    WTRIAL = WWW1(I)
        PHITRI = PPHI(I)
7125    Continue
7126    CALL   MPHI(PAX1,BMCL,WW1,PHI1,WEEP,WU1,NM1,UUF1,WTN,KONT,T1,T2)
        IF(NM1 .GT. 0)   GOTO   9111
        IF(PAX1 .EQ. 0.0)   GOTO  7119
        IF(T1 .GT. 0.0)   GO   TO   7177
        WTRIAL = (BMCL*DCGC)/EI(I)
        PHITRI  = WTRIAL  / DCGC
        GOTO   7076
7177    WTRIAL=WWP1(I)
        PHITRI=PPHIP(I)
        IF(NM2 .GT. 0.0) GO TO 7117
7076    Continue
        !7076    CALL MPHI ()

        IF(NM2.GT. 0.0) GO TO 7117
        DNAX3 = WP1/PHIP1
        DNAX1 = WW1/PHI1
        WCGC1 = PHI1*(DNAX1-DCGC)
        WCGCP1 = PHIP1*(DNAX3-DCGC)
        WAXIAL1 = WCGC1-WCGCP1
        IF(WAXIAL1 .EQ. 0.0) WAXIAL1=WCGC1
        EA(I) = ABS(PAX1/WAXIAL1)
        GO TO 7118
7119    EA(I)=ABS(ECON*DDB(I)*WWl/PHID)
        GO TO 7118
7117    EA(I) =EEAA(I)
7118    CONTINUE
        EI(I) = ABS(BMCL/PHI1)
        WUW=WU1(NSEX,1)
        WRITE(*,613) WW1,WTN,PHI1,PAX1,BMCL, EI(I),EA(I),I
613     Format(5X,3E15.5,4E14.5,I8)
        EIII(NCYCL,I) = EI(I)
        EAAA(NCYCL,I)=  EA(I)
        WWW2(I)=WW1
        PPH2(I)=PHI1
        WWP2(I)=WP1
        PPHI2(I)=PHIP1
9991 END DO
    IF(NCYCL.LE.I)   GOTO 9573
    KADD2 = 0
    KADD =   0
    DO  7379   I= 1,NPLAST
        IF(NCYCL .GE. 8)   GO  TO   5127
        GOTO   8128
5127    RATIO = (EIII(NCYCL,I)-EIII(NCYCL-1,I) ) /EIII(NCYCL,I)
        GOTO   8129
8128    RATIO1=(EI(I)-EEI(I))/EI(I)
8129    RATIO2=(EAAA(NCYCL,I)-EAAA(NCYCL-1,I)/EAAA(NCYCL,I))
        RATIOI=ABS(RATIO1)
        RATIOA=ABS(RATIO2)
        IF(NCYCL.GT.5)   GOTo   7009
        IF(RATIOI .LE. 0.01 .AND. RATIOA .LE. 0.01) KADD2 = KADD2 + 1
        IF(NCYCL .LE.   5) GOTO   7008
7009    IF(NCYCL.GT.10)   GO   TO   7007
        IF(RATIOI .LE.0.02 .AND. RATIOA .LE. 0.02)   KADD2=KADD2+1
        IF(NCYCL.LE.10)   GOTO   7008
7007    IF(NCYCL.GT.15) GO TO 7006
        IF(RATIOI .LE.0.04 .AND. RATIOA .LE. 0.04) KADD2=KADD2+1
        IF(NCYCL .LE. 15) GOTO 7008
7006    IF(NCYCL .GT. 20) GOTO 7008
        IF(RATIOI .LE. 0.10 .AND. RATIOA .LE. 0.10) KADD2=KADD2 + 1
7008    CONTINUE
7379 CONTINUE
    IF(KADD2 .EQ.  NPLAST) GO To 5555
    GOTO 9573
5555 WRITE(*,9273)
9273 FORMAT(40X,"---------CORRECT ANSWER------------------")
    DO 7072 I=1,NPLAST
        EEAA(I)=EA(I)
        WWW1(I)=WWW2(I)
        PPHI(I)=PPH2(I)
        WWP1(I)=WWP2(I)
        PPHIP(I)=PPHI2(I)
7072 END Do
    IF(WUW.GT.0.0038) GOTO 3456
    IF(T1 .EQ. 730.0) GO TO 8881


    !-----------------------------------------------------------------------------------
    !-----------------------------------------------------------------------------------
    !   READ AN INDEX = 1 IF THE PROGRAM TO BE TERMINATED AT THIS STAGE
    !   OR IF A NEW START IS DESIRED AND EQUALS 0 OTHERWISE
    !   THIS WILL ALSO READ THE TIME Tl AND THE TIME T2 FOR
    !   THE CREEP AND SHRINKAGE CALCULATIONS.
    !-----------------------------------------------------------------------------------
    !-----------------------------------------------------------------------------------
1111 If(NSE .gt. 0) then
        flag = 1
    endif

    READ(10,*) INDEXX,T1,T2
    Write(12,2103)INDEXX,T1,T2
2103 Format(/,20X,"    Index   No. ", 2X, I5,10X,"TIME 1 :: ",F10.3,5X,"TIME   2   :: "   ,F10.3)
9996 FORMAT(I5,2F10.3)
    TDEL=T2-T1
    IF(T2 .EQ. 0.0 .OR. TDEL .EQ. 0.0)   GOTO 8881
    DO   1970   I=1,NPLAST
        KONT1=I
        CALL CREEP (WEEP,WU1,UUF1,KONT1,T1,T2)  !<WEEP,WU1UUFl,KONT1T1T2)
        CALL CREEP (WEEP,WU2,UUF2,KONT1,T1,T2) !<WEEPWU?UUF?KONTl,TlT2)
1970 CONTINUE
8881 NSE=NSE+1
    GO TO 9111
3456 WRITE(*,3459)
3459 FORMAT (40X,"-------------COMP FAILURE  ------------")
    GOTO 4373
9573 CONTINUE
126 IF(NCYCL .LT. MCYCL) GO TO 16
    WRITE(*,8127)
8127 FORMAT(20X,"-----  NO   CONVERGENCE  --------")
9373 CONTINUE

    STOP "          Problem completed."

    !  Known Errors
4373 Write(*,8126)
    Write(12,8126)

8126 FORMAT("-----  I must stop as you have more than 1000 loaded joints and I cannot solve that large a problem.  --------")



    end program HEBE

    !----------------------------------------------------------------------------------------------------------------
    !
    !
    !
    !----------------------------------------------------------------------------------------------------------------

    SUBROUTINE ELASTO(EI,EA, FA,FV, BMC, LIST)
    implicit none

    INTEGER ND(100,3)
    REAL X(100),Y(100)
    INTEGER JNL(150), JNG(150),MEMTYP(150),NJ, NM
    REAL CF
    INTEGER NJL , JNN(100)
    REAL FXX(100), FYY(100),FMM(100), AL(150),XM(150) ,YM(150)
    REAL VF,AF,BM1,BM2,DV2,DV1

    Integer NB, NDIS, I,II, N1, N2, K,M,J, NB1, JJ,LL,JN, N3, L,KA, IA,JA

    INTEGER MC(150,6), MT, MAX, MIN, NV
    REAL SM(150,6,6),SK(12,12)
    REAL AA, CC, DD,EE
    REAl EI(150),EA(150),FA(150),FV(150), BMC(150), BB, GG,HH,A(10000),B(3000)
    REAL YY, XX, ALL, FX,FY,FM, DET
    REAL D1(100),D2(100),D3(100),D(6),F(3)
    INTEGER ipivot(100),iflag,LIST(100)
    REAL c(100),dA(100),BA(100)

    COMMON /BLCK1/ ND, X, Y, JNL, JNG, MEMTYP
    COMMON /BLCK2/ NJ, NM, CF, NJL
    COMMON /BLCK3/ JNN, FXX, FYY,FMM
    COMMON /BLCK5/ AL,XM ,YM

    !   PLANE FRAME PROGRAM USING A BAND SOLUTION METHOD,
    !   PROGRAM   DIMENSIONED   FOR   100 JOINTS   AND   150   MEMBERS.

    NB = 0
    NDIS=0

    write(*,100)
    write(12,110)
100 Format(//40X,"  Running the Elastic Package")
110 Format(//20X,"    Running the Elastic Package")

    DO   12   I=1,NJ
        DO   12   II=1,3
            IF(ND(I,II) .EQ. 0)   GOTo   12
            NDIS=NDIS + 1
            ND(I,II)=NDIS
12  CONTINUE
    DO   15   I=1,NM
        N1=JNL(I)
        N2=JNG(I)
        DO   15   K=1,3
            MC(I,K)=ND(N1,K)
            M = K + 3
            MC(I,M) =ND(N2,K)
15  CONTINUE
    DO 21 I = 1, NM
        Do 21 J = 1,6
            DO 21 K = 1,6
                SM(I,J,K) = 0.
21  END DO

    DO 22 I=1,NM
        write(12,5)I
5       Format(/,20X,"    Stiffness elements for the Element No :: ",I10,&
            /,20X,"     Row          1              2              3              4              5              6")
        MT=MEMTYP(I)
        AA=EA(I)/AL(I)**3
        CC=XM(I)**2
        DD=YM(I)**2
        EE=XM(I)*YM(I)

        SM(I,1,1) = AA*CC
        SM(I,2,1) = AA*EE
        SM(I,2,2) = AA*DD
        SM(I,4,1)=-SM(I,1,1)
        SM(I,4,2)=-SM(I,2,1)
        SM(I,4,4)= SM(I,1,1)
        SM(I,5,1)= SM(I,4,2)
        SM(I,5,2)=-SM(I,2,2)
        SM(I,5,4)= SM(I,2,1)
        SM(I,5,5)= SM(I,2,2)

        GOTO (23,24,25,25)MT

24      BB = 12.0*EI(I)/AL(I)**5
        GOTO 26
25      BB = 3.0*EI(I)/AL(I)**5
26      EE = BB*DD
        GG = BB*EE
        HH = BB*CC
        YY = YM(I)*BB*AL(I)**2/2.0
        XX = XM(I)*BB*AL(I)**2/2.0
        ALL = BB*AL(I)**4/3.0

        SM(I,1,1)=SM(I,1,1) + EE
        SM(I,2,1)=SM(I,2,1) - GG
        SM(I,2,2)=SM(I,2,2) + HH
        SM(I,4,1)=SM(I,4,1) - EE
        SM(I,4,2)=SM(I,4,2) + GG
        SM(I,4,4)=SM(I,4,4) + EE
        SM(I,5,1)=SM(I,5,1) + GG
        SM(I,5,2)=SM(I,5,2) - HH
        SM(I,5,4)=SM(I,5,4) - GG
        SM(I,5,5)=SM(I,5,5) + HH
        GOTO(23,28,29,31)MT
28      SM(I,3,1)=SM(I,3,1) - YY
        SM(I,3,2)=SM(I,3,2) + XX
        SM(I,3,3)=SM(I,3,3) + ALL
        SM(I,4,3)=SM(I,4,3) + YY
        SM(I,5,3)=SM(I,5,3) - XX
        SM(I,6,1)=SM(I,6,1) - YY
        SM(I,6,2)=SM(I,6,2) + XX
        SM(I,6,3)=SM(I,6,3) + ALL/2.0
        SM(I,6,4)=SM(I,6,4) + YY
        SM(I,6,5)=SM(I,6,5) - XX
        SM(I,6,6)=SM(I,6,6) + ALL
        GOTO 23
29      SM(I,6,1)=SM(I,6,1) - 2.0*YY
        SM(I,6,2)=SM(I,6,2) + 2.0*XX
        SM(I,6,4)=SM(I,6,4) + 2.0*YY
        SM(I,6,5)=SM(I,6,5) - 2.0*XX
        SM(I,6,6)=SM(I,6,6) + 3.0*ALL
        GOTO 23
31      SM(I,3,1)=SM(I,3,1) - 2.0*YY
        SM(I,3,2)=SM(I,3,2) + 2.0*XX
        SM(I,3,3)=SM(I,3,3) + 3.0*ALL
        SM(I,4,3)=SM(I,4,3) + 2.0*YY
        SM(I,5,3)=SM(I,5,3) - 2.0*XX

23      DO 32 J = 1,6
            Do 33 K = 1,6
                SM(I,J,K)=SM(I,K,J)
33          END DO
            Write(12,10)J,(SM(I,J,M),M=1,6)
10          Format(20X,I6,6F15.3)
32      END DO

22  End do

       Do 39 I = 1,NM

        kA = 0
        Do 41 IA = 1,6
            DO 42 JA = 1,6
            SK(KA+IA,KA+JA) = SM(I,IA,JA) + SK(KA+IA,KA+JA)
            write(*,*)KA+IA,KA+JA,SK(KA+IA,KA+JA)
42      end do
41      end do
KA = KA + 3
39    END DO

    call factor(sk,sk,ipivot,b,12,iflag)

    DO  200   I=1,NM
        MAX=0
        MIN = 3000

        DO 201 J = 1,6

            IF(MC(I,J) .eq. 0) GOTO 201
            IF(MC(I,J)-MAX)203,203,204
204         MAX = MC(I,J)
203         IF(MC(I,J)-MIN)205,201,201
205         MAX=MC(I,J)
201     CONTINUE
        NB1 = MAX - MIN
        IF(NB1.GT.NB)NB=NB1
200 END DO


    NB=NB+1
    NV=NDIS*NB

    IF(NV.LE. 10000) GO TO 210
    write(*,1000)NV
1000 FORMAT(20X,"STORAGE   EXCEEDED NV :: ",I6/)
    STOP
210 CONTINUE

    DO 511 I = 1,NV
        A(I) = 0.0
511 END DO
    DO  513     I=1,NDIS
        B(I)=0.0
513 END DO
    DO 521 I = 1,NM
        DO 522 JJ = 1,6
            IF(MC(I,JJ) .EQ. 0) GOTO   522
            DO 523 II =JJ,6
                IF(MC(I,II) .EQ. 0) GOTO   523
                IF(MC(I,JJ)-MC(I,II))524,525,525
525             K=(MC(I,II)-1)*(NB-1) + MC(I,JJ)
                A(K)=A(K) + SM(I,JJ,II)
                GOTO   523
524             K=(MC(I,JJ))*(NB-1)+MC(I,II)
                A(K)=A(K) + SM(I,JJ,II)

523         END DO
522     END DO
521 END DO

    LL=   1
    DO   81 K=1,NJL
        JN = JNN(K)
        FX = FXX(K)
        FY = FYY(K)
        FM=FMM(K)
        N1=ND(JN,1)
        IF(N1 .EQ. 0 .AND. FX .EQ. 0.0) GOTO 58
        IF(N1 .EQ. 0) GOTO 59
        B(N1)=B(N1)+FX
58      N2=ND(JN,2)
        IF(N2.EQ. 0 .AND. FY.EQ. 0.) GOTO 61
        IF(N2.EQ.0)GO TO 62
        B(N2) = B(N2) + FY
61      N3=ND(JN,3)
        IF(N3.EQ. 0 .AND. FM .EQ. 0.0) GOTO 81
        IF(N3 .EQ. 0) GOTO 80
        B(N3)=B(N3)+FM
        GOTO 81
59      WRITE(*,64)FX,JN
64      Format( "FORCE OF ",F10.2,1X,"KIPS IN HOR DIR AT JOINT ",I3," IS IGNORED SINCE JOINT SUPPORTED")
        GO TO 58
62      WRITE(*,165)FY,JN
165     Format("FORCE OF ",F10.2,1X,"KIPS IN VER DIR AT JOINT ",I3," IS IGNORED SINCE JOINT SUPPORTED")
        GO   TO   61
80      WRITE(*,66)FM,JN
66      Format("MOMENT OF ",F10.2,1X,"IN-KIPS IN AT JOINT ",I3," IS IGNORED SINCE JOINT SUPPORTED")
81  END DO
    DET=0.1E-07
    CALL BAND (A,B,NDIS,NB,LL,DET)
    IF(DET)266,267,268
266 WRITE(*,269)DET
269 FORMAT (40X,"DETERMINANT   IS   NEGATIVE :: ",F15.8,//)
    STOP
267 WRITE(*,270)DET
270 FORMAT (40X,"DETERMINANT   IS   ZERO.            DET :: ",F15.8,// )
    STOP
268 CONTINUE
    WRITE(*,72)
72  FORMAT(/,40X,"DlSPLACEMENT  VECTOR",/,20X,"JOINT  NO'.    HORZ  DIS (IN)     VERT DIS (IN)      ROTATION (RADIANS) " /)
    DO 74   L=1,NJ
        N1 = ND(L,1)
        N2 = ND(L,2)
        N3 = ND(L,3)
        IF(N1)101,101,102
102     D1(L) = B(N1)
        GOTO 103
101     D1(L) = 0.0
103     IF(N2)104,104,105
105     D2(L)=B(N2)
        GOTO 106
104     D2(L)=0.0
106     IF(N3)107,107,108
108     D3(L) = B(N3)
        GOTO   109
107     D3(L)=0.0
109     WRITE(*,73)L,D1(L),D2(L),D3(L)
73      FORMAT(20X,I6,6X,F11.6,5X,F11.6,5X,F14.6)
74  CONTINUE
    WRiTE(*,75)
75  FORMAT(//,40X,"FORCE VECTOR IN MEMBER CORDINATE",/,20X,&
        "  MEMBER No.     AXIAL FORCE (KIPS)    SHEAR(KIPS)    JNL BM (IN-KIP)   JNG  BM (IN-KIP)")
    DO 76  M=1,NM
        N1=JNL(M)
        N2 = JNG(M)
        D(1) = D1(N1)
        D(2) = D2(N1)
        D(3) = D3(N1)
        D(4) = D1(N2)
        D(5) = D2(N2)
        D(6) = D3(N2)
        DO 77 I=1,3
            F(I) = 0.0
            DO 77  J=l,6
                F(I) = F(I) + SM(M,I,J)*D(J)
77      END DO
        VF=(-F(1)*YM(M)+F(2)*XM(M))/AL(M)
        AF=(-F(1)*XM(M)-F(2)*YM(M))/AL(M)
        BM1 = -F(3)
        BM2 = BM1 + VF*AL(M)

        WRITE(*,78)M,AF,VF,BM1,BM2
78      FORMAT(20X,I7,5X,F12.4,8X,F12.4,2X,F12.4,6X,F12.4)
        FA(M) = AF
        FV(M) = VF
        DV2 = (-D(4)*YM(M) + D(5)*XM(M))/AL(M)
        DV1 = (-D(1)*YM(M) + D(2)*XM(M))/AL(M)
        BMC(M)=BM1+VF*AL(M)*0.50-AF*(DV1+DV2)*0.5
76  END DO

    RETURN
    END SUBROUTINE


    !----------------------------------------------------------------------------------------------------------------
    !
    !
    !
    !----------------------------------------------------------------------------------------------------------------


    SUBROUTINE MPHI(PAXIAL,BMOM,STRAIN,CURVA,WEEP,WU, NM, UUF1,WTE,KONT,T1,T2)
    Implicit none

    REAL PAXIAL,BMOM,STRAIN,CURVA,WU(20,20)
    Integer NM,KONT
    REAL WTE
    REal T1,T2

    REAL DTH,DB,AST,ASC,DST,DSC,UC,UT,UP2,UP3
    REAL WSHRS, WSHRC, WTENSIL, WY, FSY, ECYL, ECF,SUP,UP1
    INTEGER NALLOW,NEK
    REAL ES,PCAL3,A13,A21,BMCAL2,BMCAL3
    REAL PHITRI, WTRIAL, CYL, ECI, BMCAL1,CCA,WINC

    REAL UUF1(20,20), P, WG(20,20),WH(20,20), ERR1, ERR2
    REAL WEEP(20,20), EROR,CCB, BM,TDEL,W,PHI,WCF,EC, PCAL1
    Integer NSTRIP,KADD,KDD, KOUNT, LM,LN
    REAL PHINC,WNEW, PHINEW,PCAL2,A11,A12,A22,W4,PHIDEL,WDEL,RR,A23

    COMMON /BLOCK1/ DTH,DB,AST,ASC,DST,DSC
    COMMON /BLOCK3/ WSHRS, WSHRC
    COMMON /BLOCK4/ WTENSIL, WY, FSY, ECYL, ECF, NALLOW, ES
    COMMON /BLOCK5/ PHITRI, WTRIAL

    ECI = 1.0
    NSTRIP = 0
    KADD = 0
    CCA = 5.0E-4
    CCB  =   5.0E-4
    EROR = 0.01
    KDD = 0
    P  =   PAXIAL
    BM   =   BMOM
    TDEL = T2 - T1
    W = WTRIAL
    PHI = PHITRI
334 WCF   =   145.0
    EC   =   33.*WCF**1.5*(ECYL*1000.0)**0.50/1000.
    WSHRS   =      (DB*DTH-AST-ASC)*EC*WSHRC/((AST+ASC)*ES)
    KOUNT   =   0
    LM   =   KONT
    IF(T2)2388,2388,3377
2388 CYL = ECYL
    DO 3388 LN = 1,NSTRIP
3388 WEEP(LM,LN) = 0.0
    GOTO  444
3377 ECI =  ECYL
    IF(T2 .LE. 0.0 .OR. TDEL .EQ. 0.0)   GOTO  444
    CYL = (1.0+ECF)*ECI
    IF(T2.LE. 120.) THEN
        CYL = ( 1.0+ECF*T2/120.0)*ECI
    END IF
444 CONTINUE
416 CALL BMPCAL(W,PHI,PCAL1,BMCAL1,WU,WEEP,CYL,W4,LM)    !{WPHI.PCALl8MCALlWUWEEPiCYLW4LM)
    KOUNT   =   KOUNT   +1
    IF(KOUNT .GT. 40) EROR=0.02
    IF(KOUNT .GT. 60) EROR=0.05
    IF(KADD .GT. 0) GO TO 848
    IF(W.GE.2.0*WTRIAL .AND. T1 .GT. 0.0)   GOTO   608
848 IF(P .EQ. 0.0)  P = 1.0
    IF(BM .EQ. 0.0) BM =   1.0
    ERR1   =   ABS((P-PCAL1)/P)
    ERR2   =   ABS((BM - BMCAL1)/BM)
    IF(P .LE. 1.0 .AND. ABS(PCAL1) .le. 3.00)   ERR1=0.01
    IF(ABS(BM) .LE. 10.0) ERR2=ABS(BM-ABS(BMCAL1))/100.0
    IF(ERR1.LE.EROR .AND. ERR2 .LE. EROR) GO TO 600
    IF(ABS(BM) .LE. 10.0)  GO TO 7712
    GO TO 3012
7712 EROR = 0.20
    IF(BMCAL1 .LE. 10.0 .AND. ERR1 .LE. EROR) GOTO 600
    IF(T2 .GT. 0.  .AND. BMCAL1 .LE. 10.0) GOTO 600
3012 CONTINUE
    IF(P .LE. 1.0 .AND. ERR1 .EQ. 0.01) GOTO 103
    GOTO 203
103 IF(KADD .EQ. 1) GO TO 944
203 IF(KADD .GT. 0) GO TO 600
    WINC = CCA*W +  CCB
    PHINC = CCA*PHI + CCB
    IF(WINC .EQ. 0.0 .OR. PHINC .EQ. 0.0) GOTO 608
    WNEW = W + WINC
    PHINEW = PHI + PHINC
    CALL BMPCAL(W,PHINEW,PCAL2,BMCAL2,WG,WEEP,CYL,W4,LM)
    CALL BMPCAL(WNEW,PHI,PCAL3,BMCAL3,WH,WEEP,CYL,W4,LM)
    A11   = (PCAL2-PCAL1)/PHINC
    A12   = (PCAL3-PCAL1)/WINC
    A13   = P - PCAL1
    A21   = (BMCAL2 - BMCAL1)/PHINC
    A22   = (BMCAL3-BMCAL1)/WINC
    A23   = BM   -  BMCAL1
    RR   =   A11*A22-A21*A12
    IF (RR .EQ. 0.0)   GOTO   608
    WDEL =(A11*A23-A13*A21)/RR
    PHIDEL = (A13*A22 - A23*A12)/RR
    PHI = PHI + PHIDEL
    W   =   W   +  WDEL
    IF(KOUNT-NALLOW)436,436,608
600 STRAIN = W
    CURVA = PHI
    WTE = W4
    NM = 0
    IF(CURVA .LE. 0.0)   GOTO   608
    RETURN
608 WRITE(*,666)
666 FORMAT(10X,"_____________________________________________________________________________________________________",/)
    KOUNT = 0
    W=WTRIAL
    PHI=PHITRI
    GO   TO   436
    SUP = ABS((W-W4)/W)
    IF(P .EQ. 1.0) NEK = 0
    IF(NEK .EQ. 1)   GOTO   898
677 IF(SUP - 0.05)   642,641,641
642 UP1=0.0001*(P-PCAL1)/(10.0*P)
    IF(P .LE. 10.0)   UP1 = 0.0001*(P - 1.0*(PCAL1))/(10.0*ABS(PCAL1))
    GO   TO   640
641 UP1=ABS(W-W4)*(P-PCAL1)/(10.0*P)
    IF(P.LE. 10.0)   UP1=ABS(W-W4)*(P-1.*(PCAL1))/(10.0*ABS(PCAL1))
640 UC = W + UP1
    UT = W4 + UP1
    NEK = 1
    GOTO   888
    IF(SUP-0.05) 675,671,671
675 UP2=0.0001*(BM-BMCAL1)/(10.0*BM)
    IF(BM .LE. 10.0) UP2 = 0.0001*(BM-BMCAL1)/(10.0*ABS(BMCAL1))
    GO TO 658
671 UP2=ABS(W-W4)*(BM-BMCAL1)/(10.0*BM)
    IF(BM .LE. 10.0) UP2=ABS(W-W4)*(BM-BMCAL1)/(10.0*ABS(BMCAL1))
658 UC = W + UP2
    UT = W4 - UP2
    NEK = 0
    GOTO   888
944 SUP=ABS((W-W4)/W)
977 IF(SUP - 0.05)945,946,946
945 UP3 = ABS(W4/(W-W4))*0.0001*(BM-BMCAL1/(10.0*BM))
    IF(BM .LE. 10.0) UP3 = ABS(W4/(W-W4))*0.0001*(BM-BMCAL1)/(10.0*ABS(BMCAL1))
    UP2 =ABS(W/( W-W4))*0.0001*(BM-BMCAL1)/(10.0*BM)
    IF(BM .LE. 10.0) UP2 = ABS(W4/(W-W4))*0.0001*(BM-BMCAL1)/(10.0*ABS(BMCAL1))
    GOTO  947
946 UP3=ABS(W4)*(BM-BMCAL1)/(10.0*BM)
    IF(BM .LE. 10.0) UP3=ABS(W4)*(BM-BMCAL1)/(10.0*ABS(BMCAL1))
    UP2=ABS(W)*(BM-BMCAL1)/(10.0*BM)
    IF(BM .le. 10.0) UP2=ABS(W)*(BM-BMCAl1)/(10.0*ABS(BMCAL1))
947 UC = W + UP2
    UT = W4 - UP3
888 PHI=(UC-UT)/DTH
    W=UC
    W4=UT
    IF(W .GT. 10.0**5) GO TO 123
    IF(KOUNT -100)436,436,123
123 WRITE(*,198)
198 FORMAT(40x,"------------------------------------------------------------------------")
    STRAIN = 0.0015
    CURVA = 0.0002
436 Continue
898 CONTINUE
    RETURN
    END SUBROUTINE


    !----------------------------------------------------------------------------------------------------------------
    !
    !
    !
    !----------------------------------------------------------------------------------------------------------------



    SUBROUTINE CREEP(WEEP,WU,UUF1,KONT1,T1,T2)

    IMPLICIT NONE
    REAL WEEP(20,20),WU(20,20),UUF1(20,20),T1,T2
    Integer KONT1, NSTRIP,L,I,J
    REAL A1,A2,A3,A4,B1,B2,B3,B4,SHRINK,SSRR,T,CLU,X,OLDU,Y,SOLD


    NSTRIP = 20
    A1 = -1.03050E+06
    A2 =  5.748870E+02
    A3 = -3.776740E-01
    A4 = -3.072250E-06
    B1 = 1.858390E+06
    B2 = -1.012295E+03
    B3 = 1.5215225
    B4 = -7.9862500E-06
    L = KONT1
    IF(T1 .GT. 0.0)   GOTO 87
    SHRINK=-0.000111+0.000224*ALOG10(T2)
    GOTO  88
87  IF(T2 .GT. 700.) GOTO 129
    SHRINK=0.000224*(ALOG10(T2)-ALOG10(T1))
    GOTO 88
129 SHRINK = 0.000224*(ALOG10(700.0) - ALOG10(T1))
88  SSRR =   SHRINK

    write(12,1000)NSTRIP,A1,A2,A3,A4,B1,B2,B3,B4,L,SHRINK
1000 Format(/,20X,"    Creep Subroutine",&
        /,20X,"    NSTRIP            :: ",I10,&
        /,20x,"    A1                :: ",E10.3,&
        /,20x,"    A2                :: ",E10.3,&
        /,20x,"    A3                :: ",E10.3,&
        /,20x,"    A4                :: ",E10.3,&
        /,20x,"    B1                :: ",E10.3,&
        /,20x,"    B2                :: ",E10.3,&
        /,20x,"    B3                :: ",E10.3,&
        /,20x,"    B4                :: ",E10.3,&
        /,20x,"    L                 :: ",I10,&
        /,20x,"    Shrink            :: ",E10.3,&
        //20X,"    WEEP ARRAY - 20 X 20",/)


    IF(T1 .GT. 700.)   SSRR = 0.0
    IF(T1 .GT. 0.0)   GOTO   67
    DO 69 I=1,NSTRIP
        CLU=WU(L,I)
        X = CLU
        IF(X)124,124,125
125     WEEP(L,I) = (A1*X**3 + A2*X**2+A3*X + A4) + (B1*X**3+B2*X**2+B3*X+B4)* ALOG10(T2) +   SSRR
        UUF1(L,I) = X
        GOTO 69
124     WEEP(L,I) = SSRR
        UUF1(L,I) = 0.0
69  END DO

    Do 50 I = 1,NSTRIP
        Write(12,51)(WEEP(J,I),j=1,20)
51      Format(20X,20(2x,E10.3))
50  END DO
    RETURN
67  DO 75 I = 1, NSTRIP
        CLU = WU(L,I)
        X = CLU
        If(X)988,988,987
987     OLDU=(X-UUF1(L,I))
        Y = OLDU
        IF(Y .LE. 0.0) GOTO 998
        SOLD = (A1*Y**3+A2*Y**2+A3*Y+A4)+ (B1*Y**3+B2*Y**2+B3*Y+B4)*ALOG10(T2-T1)
        GOTO 999
988     SOLD = 0.0

        WEEP(L,I) = (B1*X**3+B2*X**2+B3*X+B4)*(ALOG10(T2)-ALOG10(T1))+SSRR + SOLD+WEEP(L,I)
        UUF1(L,I) = CLU
        GOTO 75
999     WEEP(L,I) = WEEP(L,I) + SSRR
        UUF1(L,I) = 0.0
75  CONTINUE
998 Continue                            ! Find correct location
    RETURN
    END SUBROUTINE


    !----------------------------------------------------------------------------------------------------------------
    !
    !
    !
    !----------------------------------------------------------------------------------------------------------------



    SUBROUTINE BMPCAL(W,PHI,PCAL,BMCAL,WU,WEEP,CYL,W4,L)

    IMPLICIT NONE

    REAL WPHI,PCAL,BMCAL,WU(20,20),PHI, W,W4,WEEP(20,20)
    REAL DTH,DB,AST,ASC,DST,DSC,WSHRINS, WSHRINC
    REAL WTENSIL, WY, FSY,WX,STRESS,PCONCR,WA,BMCONC
    REAL CYL,ECYL
    REAL TCF, ES,NSTRIP,DL,DCGC,W1,WI,DNAXIS,W2,W3,DX,PCON,BMCON,DUM
    Integer NALLOW,L,I
    REAL WB,STEEL2,STEEL3,PS2,PS3,BMS2,BMS3


    COMMON /BLOCK1/ DTH,DB,AST,ASC,DST,DSC
    COMMON /BLOCK3/ WSHRINS, WSHRINC
    COMMON /BLOCK4/ WTENSIL, WY, FSY, ECYL, TCF, NALLOW, ES

    NSTRIP =20
    DL = DTH/NSTRIP
    DCGC = (DB*DTH**2*0.5+AST*DST+ASC*DSC)/(DB*DTH + ASC + AST)
    W1 =  W
    DNAXIS = WI/PHI
    W2 = (DNAXIS - DSC)*PHI + WSHRINS
    W3 = (DNAXIS - DST)*PHI + WSHRINS
    W4 = PHI*(DNAXIS-DTH)
    DX = DCGC   +   0.5*DL
    PCON = 0.0
    BMCON = 0.0
    DO 100 I = 1,NSTRIP
        DX = DX - DL
        DUM = FLOAT(I)
        WU(L,I)=PHI*(DNAXIS + DL*0.50-DL*DUM) - WEEP(L,I) - WSHRINC
100 WX = WU(L,I)
    IF(WX+WTENSIL)10,20,20
10  STRESS = 0.0
    GOTO 30
    STRESS=CYL* (-4.5005079E09*WX**4 +7.6164509E+07*WX**3-4.8022753E+05*WX**2+1.1902628E+03*WX)
30  PCONCR   =   STRESS*DB*DL
    BMCONC   =   BMCON + BMCONC
20  CONTINUE
    IF(W2 .EQ. 0.0) W2 = 1.0
    IF(W3 .EQ. 0.0) W3 = 1.0
    WA = ABS(W2)
    WB = ABS(W3)
    STEEL2= FSY*W2*(WA+WY-ABS(WA-WY) )/(2.0*WY*WA)
    STEEL3= FSY*W3*(WB+WY-ABS(WB-WY) )/(2.0*WY*WB)
    IF(W2 .EQ. 0.0) STEEL2= 0.0
    IF(W3 .EQ. 0.0) STEEL3=0.0
    PS2 = ASC*STEEL2
    PS3= AST*STEEL3
    BMS2= PS2*(DCGC-DSC)
    BMS3 = PS3*(DCGC -DST)
    PCAL = PCON + PS2 + PS3
    BMCAL = BMCON + BMS2+BMS3
    RETURN
    END

    !----------------------------------------------------------------------------------------------------------------
    !
    !
    !
    !----------------------------------------------------------------------------------------------------------------


    SUBROUTINE BAND(A,B,N,M,LT,DET)
    IMPLICIT NONE

    REAL A(10000),B(3000)
    Integer N,M,LT,MM, NM1,NM, MP,KK,J,JP,II,JC,I,KM,KJ
    INTEGER IM,KI,K,NROW,L,LM,K1,JK,NL,NL1,NJ1, MM1, NMM,NN,ND
    REAL S, BSUM1, BSUM2
    REAL DET,FAC,BIG,SML, BIGL, MZC, MMZC, ASUM1, ASUM2

    MM = M - 1
    NM = N*M
    NM1 = NM - MM
    IF(LT .NE. 1) GOTO 55
    MP=M+1
    KK=2
    FAC=DET
    A(1) = 1.0/SQRT(A(1))
    BIGL=A(1)
    SML = A(1)
    A(2)=A(2)*A(1)
    A(MP)=1.0/SQRT(A(MP)-A(2)*A(2))
    IF(A(MP) .GT. BIGL)BIGL=A(MP)
    IF ( A(MP) .LT. SML) SML = A(MP)
    MP = MP + M
    !******************************************************************************************************************************* DO 62, J
    DO 62 J=MP,NM1,M
        JP = J - MM
        MZC = 0
        IF(KK .GE. M) GOTO 1
        KK = KK + 1
        II = 1
        JC = 1
        GOTO 2
        KK = KK + M
        II = KK - MM
        JC = KK - MM
        !****************************************************************************************************DO 65 I
        DO 65  I = KK,JP,MM
            IF(A(I) .EQ. 0.) GOTO 64
            GOTO 66
64          JC=JC+M
            MZC = MZC + 1
65  END DO
    !****************************************************************************************************END DO 65 I
    ASUM1 = 0.
    GOTO  61
66  MMZC = MM*MZC
    II = II + MZC
    KM = KK + MMZC
    A(KM) = A(KM)*A(JC)

    IF(KM .GE. JP) GOTO   6
    KJ = KM + MM
    !*******************************************************************************************************DO LOOP 5   I
    DO 5   I=KJ,JP,MM
        ASUM2 = 0.0
        IM = I-MM
        II = II + 1
5   KI = II + MMZC
    !*******************************************************************************************************END DO LOOP 5   I
    DO 7 K = KM,IM,MM
        ASUM2 = ASUM2 + A(KI)*A(K)
        KI = KI + MM

        A(I) = (A(I)-ASUM2)*A(KI)
7   END DO
    !*******************************************************************************************************END DO LOOP 5   I
6   CONTINUE
    ASUM1=0.

    !*******************************************************************************************************DO LOOP 4   K
    DO 4   K=KM,JP,MM
        ASUM1=ASUM1+A(K)*A(K)
        S=A(J)-ASUM1
4   END DO
    !*******************************************************************************************************END DO LOOP 4   K
    IF(S .LT. 0.0 ) DET=S
    IF(S .GT. 0.0) GOTO  63
    NROW = (J + MM)/M
    WRITE(*,99)NROW
99  FORMAT (35H ERROR CONDITION ENCOUNTEREDIN  ROW, I6)
    RETURN
63  IF(A(J) .GT. BIGL)BIGL = A(J)
    IF(A(J) .LT. SML) SML = A(J)
52  CONTINUE
    IF(SML .LE. FAC*BIGL)GO TO 54
    GO TO 53
54  DET=0.
    RETURN
53  DET=SML/BIGL
    B(1) = B(1)*A(1)
    KK = 1
62  KI = 1

    J = 1
    Do 8 L = 2,N
        BSUM1 = 0.0
        LM=L - 1
        J = J + M
        IF(KK.GE.M)GOTO 12
        KK = KK + 1
        GO TO 13
12      KK = KK + M
        K1 = K1 + 1
        JK=KK
        DO 9 K=K1,LM
            BSUM1 = BSUM1 + A(JK)*B(K)
            JK = JK + MM
9       CONTINUE
        B(L) = (B(L) - BSUM1) *A(J)
        B(N) = B(N)*A(NM1)
        NMM = MM1
        NN=N-1
        ND=N
8   END DO
    DO 10   L=1,NN
        BSUM2= 0.0
        NL = N - L
        NL1 = N-L+1
        NMM = NMM - M
        NJ1 = NMM
        IF(L .GE. M)ND = ND - 1
        DO 11 K = NL1,ND
            NJ1 = NJ1 + 1
            BSUM2 = BSUM2 + A(NJ1)*B(K)
11      END DO
        B(NL) = (B(NL) - BSUM2)*A(NMM)
10  End do


1   Continue
2   Continue
    RETURN
61  STOP 'ERROR 61'
55  STOP "ERROR 55"

13  STOP "ERROR 13"
    RETURN
    END SUBROUTINE
    
    
!
! *********************************************************************
!
       Subroutine Factor(a,w,ipivot,d,n,iflag)
! 
! *********************************************************************       
!
       implicit none
       
       real a(n,n),w(n,n)
       integer ipivot(n)
       real d(n)
       Integer IFLAG,I,J,nm1,K,N,KP1,IP,IPK
       real ROWMAX,amax1,COLMAX,awikov,Ratio

!
! *********************************************************************
!
!      initialize vectors
!
! *********************************************************************
!

       iflag=1

       do 10 i=1,n
        ipivot(i)=i
        rowmax=0.0
        do 20 j=1,n
         w(i,j)=a(i,j)
         rowmax=amax1(rowmax,abs(w(i,j)))
20      continue
        if(rowmax .eq. 0.0) go to 999
        d(i)=rowmax
10     continue

!
! *********************************************************************
!
!      Gaussian elimination with scaled partial pivotting
!
! *********************************************************************
!

       nm1=n-1
       if(nm1 .eq. 0) return
       do 30 k=1,nm1
        j=k
        kp1=k+1
        ip=ipivot(k)
        colmax=abs(w(ip,k))/d(ip)
        do 40 i=kp1,n
         ip=ipivot(i)
         awikov=abs(w(ip,k))/d(ip)
         if (awikov .le. colmax ) go to 40
         colmax=awikov
         j=i
40      continue
        if (colmax .eq. 0.0) go to 999
        ipk=ipivot(j)
        ipivot(j)=ipivot(k)
        ipivot(k)=ipk
        do 30 i=kp1,n
         ip=ipivot(i)
         w(ip,k)=w(ip,k)/w(ipk,k)
         ratio=-w(ip,k)
         do 30 j=kp1,n
          w(ip,j)=ratio*w(ipk,j)+w(ip,j)
30     continue
       if (w(ip,n) .eq. 0.0) go to 999
       return
999    iflag=2
       return
       end
